/* Copyright (c) 2009 Nordic Semiconductor. All Rights Reserved.
 *
 * The information contained herein is property of Nordic Semiconductor ASA.
 * Terms and conditions of usage are described in detail in NORDIC
 * SEMICONDUCTOR STANDARD SOFTWARE LICENSE AGREEMENT.
 *
 * Licensees are granted free, non-transferable use of the information. NO
 * WARRANTY of ANY KIND is provided. This heading must NOT be removed from
 * the file.
 *
 */

/** @file
* @brief Example template project.
* @defgroup nrf_templates_example Example Template
* @{
* @ingroup nrf_examples_nrf6310
*
*/

#include <stdbool.h>
#include "nrf51.h"
#include "nrf51_bitfields.h"
#include "nrf_gpio.h"
#include "nrf_gpiote.h"

#define OUT_PIN_NUMBER 8
/**
 * @brief Function for application main entry.
 */
int main(void)
{
    NRF_CLOCK->TASKS_HFCLKSTART = 1;
    
    NRF_TIMER0->CC[0] = 100;
    NRF_TIMER0->CC[1] = 250000;
    NRF_TIMER0->PRESCALER = 4;
    NRF_TIMER0->SHORTS = TIMER_SHORTS_COMPARE1_CLEAR_Enabled << TIMER_SHORTS_COMPARE1_CLEAR_Pos;
    
    nrf_gpiote_task_config(0, OUT_PIN_NUMBER, NRF_GPIOTE_POLARITY_TOGGLE, NRF_GPIOTE_INITIAL_VALUE_HIGH);
    
    NRF_PPI->CH[0].EEP = (uint32_t) &NRF_TIMER0->EVENTS_COMPARE[0];
    NRF_PPI->CH[0].TEP = (uint32_t) &NRF_GPIOTE->TASKS_OUT[0];
    NRF_PPI->CH[1].EEP = (uint32_t) &NRF_TIMER0->EVENTS_COMPARE[1];
    NRF_PPI->CH[1].TEP = (uint32_t) &NRF_GPIOTE->TASKS_OUT[0];
    NRF_PPI->CHENSET = PPI_CHENSET_CH0_Enabled << PPI_CHENSET_CH0_Pos | 
                       PPI_CHENSET_CH1_Enabled << PPI_CHENSET_CH1_Pos;
    
    NRF_TIMER0->TASKS_START = 1;
    
    while (true)
    {
        // Do nothing.
    }
}
/** @} */
